import { r as registerInstance, h, H as Host } from './index-a7a720e7.js';
import { b as onComponentRequiredPropUndefined } from './helpers-46a2d1fd.js';

const icTabGroupCss = ":host{display:block;margin-bottom:var(--ic-space-md);border-bottom:var(--ic-space-1px) solid var(--ic-tab-bottom-border)}:host(.ic-tab-group-monochrome){border-bottom:var(--ic-space-1px) solid\n    var(--ic-tab-bottom-border-monochrome)}:host(.ic-tab-group-inline){margin-bottom:0;border-bottom:none}.tabs-container{display:flex;flex-direction:row}.tabs-container::-webkit-scrollbar{display:none}:host ic-horizontal-scroll{--splitter-color:var(--ic-tab-divider)}:host(.ic-tab-group-monochrome) ic-horizontal-scroll{--splitter-color:var(--ic-tab-divider-monochrome)}";
const IcTabGroupStyle0 = icTabGroupCss;

const TabGroup = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        /**
         * If `true`, the tabs and tab panels will be positioned separately.
         */
        this.inline = false;
        /** @internal Determines whether black variant of the tabs should be displayed. */
        this.monochrome = false;
        /** @internal Determines whether the light or dark variant of the tabs should be displayed. */
        this.theme = "inherit";
    }
    componentDidLoad() {
        onComponentRequiredPropUndefined([{ prop: this.label, propName: "label" }], "Tab Group");
    }
    render() {
        const { inline, theme, label, monochrome } = this;
        return (h(Host, { key: '08da1fef9eb0a16a7f9d0f7cffff3894b3319b09', role: "tablist", "aria-label": label, class: {
                ["ic-tab-group-inline"]: !!inline,
                [`ic-theme-${theme}`]: theme !== "inherit",
                ["ic-tab-group-monochrome"]: !!monochrome,
            } }, h("ic-horizontal-scroll", { key: 'c12cc06aba78c85277b3eab2250c8e61a3b4c4da', theme: theme, "focus-trigger": "tabFocus", monochrome: monochrome }, h("div", { key: '01c299ea10f8600e2e9df303e06c4e97dcdab7c3', class: "tabs-container" }, h("slot", { key: '1f2cb7d4f2f86c7e3ba8f910797a963d15d9a7e0' })))));
    }
    static get delegatesFocus() { return true; }
};
TabGroup.style = IcTabGroupStyle0;

export { TabGroup as ic_tab_group };

//# sourceMappingURL=ic-tab-group.entry.js.map