import { IcThemeMode } from "../../utils/types";
export declare class BreadcrumbGroup {
    private ADD_CLASS_DELAY;
    private breadcrumb;
    private breadcrumbs;
    private collapsedBreadcrumbEl;
    private collapsedBreadcrumbs;
    private collapsedBreadcrumbWrapper;
    private IC_BREADCRUMB;
    private resizeObserver;
    private SHOW_BACK_ICON;
    el: HTMLIcBreadcrumbGroupElement;
    deviceSize: number;
    expandedBreadcrumbs: boolean;
    /**
     * If `true`, display only a single breadcrumb for the parent page with a back icon.
     */
    backBreadcrumbOnly?: boolean;
    watchBackBreadcrumbHandler(): void;
    /**
     * If `true`, all breadcrumbs between the first and last breadcrumb will be collapsed.
     */
    collapsed?: boolean;
    watchCollapsedHandler(): void;
    /**
     * If `true`, the breadcrumb group will display as black in the light theme, and white in the dark theme.
     */
    monochrome?: boolean;
    watchMonochromeHandler(): void;
    /**
     * Sets the theme color to the dark or light theme color. "inherit" will set the color based on the system settings or ic-theme component.
     */
    theme?: IcThemeMode;
    watchThemeHandler(): void;
    componentWillLoad(): void;
    disconnectedCallback(): void;
    private setBreadcrumbTheme;
    private setBreadcrumbMonochrome;
    private setBackBreadcrumb;
    private setBackBreadcrumbAttr;
    private getLastParentBreadcrumb;
    private lastParentBreadcrumb;
    private setDefaultBreadcrumbs;
    private setCollapsed;
    private clickHandler;
    private renderCollapsedBreadcrumb;
    private handleHiddenCollapsedBreadcrumbs;
    private transitionendHandler;
    private removeVisuallyHiddenClass;
    private setLastParentCollapsedBackBreadcrumb;
    private revertLastParentCollapsedBreadcrumb;
    private resizeObserverCallback;
    private runResizeObserver;
    render(): any;
}
